## ippsample 0.0+20180213

=== Makefile ===
#
# Top-level Makefile for IPP sample implementations.
#
# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
# Copyright © 2007-2018 by Apple Inc.
# Copyright © 1997-2007 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include Makedefs


# Source directories...
DIRS	=	\
		cups \
		server \
		tools


#
# Make all targets...
#

all:
	for dir in $(DIRS); do \
		echo Making all in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) all) || exit 1; \
	done


#
# Remove object and target files...
#

clean:
	for dir in $(DIRS); do \
		echo Cleaning all in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) clean) || exit 1; \
	done


#
# Remove all non-distribution files...
#

distclean:	clean
	$(RM) Makedefs config.h config.log config.status
	-$(RM) -r autom4te*.cache


#
# Make dependencies
#

depend:
	for dir in $(DIRS); do \
		echo Updating dependencies in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) depend) || exit 1; \
	done


#
# Install everything...
#

install:
	for dir in $(DIRS) doc; do \
		echo Installing in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) install) || exit 1; \
	done


#
# Test everything...
#

.PHONY: test

test:
	for dir in $(DIRS); do \
		echo Testing in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) test) || exit 1; \
	done
	echo Running integration tests...
	test/run-tests.sh


#
# Don't run top-level build targets in parallel...
#

.NOTPARALLEL:

=== cups/Makefile ===
#
# API library Makefile for the CUPS library.
#
# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
# Copyright © 2007-2018 by Apple Inc.
# Copyright © 1997-2006 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


#
# Options to build libcups without the use of deprecated APIs...
#

OPTIONS	=	-D_CUPS_NO_DEPRECATED=1


#
# Object files...
#

LIBOBJS	=	\
		array.o \
		auth.o \
		debug.o \
		dest.o \
		dest-job.o \
		dest-localization.o \
		dest-options.o \
		dir.o \
		encode.o \
		error.o \
		file.o \
		getputfile.o \
		globals.o \
		hash.o \
		http.o \
		http-addr.o \
		http-addrlist.o \
		http-support.o \
		ipp.o \
		ipp-file.o \
		ipp-support.o \
		ipp-vars.o \
		langprintf.o \
		language.o \
		md5.o \
		md5passwd.o \
		notify.o \
		options.o \
		pwg-media.o \
		raster.o \
		request.o \
		snprintf.o \
		string.o \
		tempfile.o \
		thread.o \
		tls.o \
		transcode.o \
		usersys.o \
		util.o
TESTOBJS =	\
		testarray.o \
		testclient.o \
		testdest.o \
		testfile.o \
		testhttp.o \
		testi18n.o \
		testipp.o \
		testoptions.o \
		testraster.o
OBJS	=	\
		$(LIBOBJS) \
		$(TESTOBJS)
HEADERS =       \
                array.h \
                cups.h \
                dir.h \
                file.h \
                http.h \
                ipp.h \
                language.h \
                pwg.h \
                raster.h \
                transcode.h \
                versioning.h


#
# Targets in this directory...
#

TARGETS =	libcups.a
TESTS	=	$(TESTOBJS:.o=)


#
# Make all targets...
#

all:		$(TARGETS)


#
# Remove object and target files...
#

clean:
	$(RM) $(OBJS) $(TARGETS) $(TESTS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install the client library...
#

install:	all
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(libdir)
	$(INSTALL_LIB) -m 755 libcups.a $(BUILDROOT)$(libdir)
	$(RANLIB) $(BUILDROOT)$(libdir)/libcups.a
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(includedir)/cups
	for file in $(HEADERS); do \
		$(INSTALL_DATA) $$file $(BUILDROOT)$(includedir)/cups; \
	done


#
# Test the library.
#

test:	$(TESTS)
	echo Running unit tests...
	for test in $(TESTS); do \
		echo ""; \
		echo Running $$test...; \
		./$$test || exit 1; \
	done


#
# libcups.a
#

libcups.a:	$(LIBOBJS)
	echo Archiving $@...
	$(RM) $@
	$(AR) $(ARFLAGS) $@ $(LIBOBJS)
	$(RANLIB) $@


#
# libcups2.def (Windows DLL exports file...)
#

libcups2.def: $(OBJS) Makefile
	echo Generating $@...
	echo "LIBRARY libcups2" >libcups2.def
	echo "VERSION 2.12" >>libcups2.def
	echo "EXPORTS" >>libcups2.def
	(nm $(OBJS) 2>/dev/null | grep "T _" | awk '{print $$3}'; \
	 echo __cups_strcpy; echo __cups_strlcat; echo __cups_strlcpy) | \
		grep -v -E \
		    -e 'cups_debug|Apple|GSSService|SetNegotiate' \
		    -e 'Block$$' | \
		sed -e '1,$$s/^_//' | sort >>libcups2.def


#
# Unit tests
#

testarray: testarray.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testarray.o $(LIBS)
testclient: testclient.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testclient.o $(LIBS)
testdest: testdest.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testdest.o $(LIBS)
testfile: testfile.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testfile.o $(LIBS)
testhttp: testhttp.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testhttp.o $(LIBS)
testi18n: testi18n.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testi18n.o $(LIBS)
testipp: testipp.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testipp.o $(LIBS)
testoptions: testoptions.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testoptions.o $(LIBS)
testraster: testraster.o
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testraster.o $(LIBS)


#
# Automatic API help files...
#

APISOURCES =	\
		auth.c \
		cups.h \
		dest.c \
		dest-job.c \
		dest-localization.c \
		dest-options.c \
		encode.c \
		error.c \
		getputfile.c \
		hash.c \
		http.c \
		http.h \
		http-addr.c \
		http-addrlist.c \
		http-support.c \
		ipp.c \
		ipp.h \
		ipp-support.c \
		md5passwd.c \
		notify.c \
		options.c \
		pwg.h \
		pwg-media.c \
		raster.c \
		raster.h \
		request.c \
		tls.c \
		usersys.c \
		util.c

apihelp:
	echo Generating CUPS API help files...
	mxmldoc --title "CUPS API Programming Guide" \
		--author "Michael R Sweet" \
		--copyright "Copyright 2007-2017 by Apple Inc." \
		--docversion $(IPPSAMPLE_VERSION) \
		--intro api.intro \
		api.xml $(APISOURCES) >../doc/api.html
	mxmldoc --title "CUPS API Programming Guide" \
		--author "Michael R Sweet" \
		--copyright "Copyright 2007-2017 by Apple Inc." \
		--docversion $(IPPSAMPLE_VERSION) \
		--intro api.intro \
		--epub ../doc/api.epub \
		api.xml
	if test `uname` = Darwin; then \
		mxmldoc --title "CUPS API Programming Guide" \
			--author "Michael R Sweet" \
			--copyright "Copyright 2007-2017 by Apple Inc." \
			--docversion $(IPPSAMPLE_VERSION) \
			--intro api.intro \
			--docset org.pwg.ippsample.docset \
			--feedname org.pwg.ippsample \
			--feedurl https://istopwg.github.io/ippsample/org.pwg.ippsample.atom \
			api.xml; \
		$(RM) org.pwg.ippsample.atom; \
		xcrun docsetutil package --output org.pwg.ippsample.xar \
			--atom org.pwg.ippsample.atom \
			--download-url https://istopwg.github.io/ippsample/org.pwg.ippsample.xar \
			org.pwg.ippsample.docset || exit 1; \
	fi
	$(RM) api.xml


#
# Dependencies...
#

include Dependencies
tls.o: tls-darwin.c tls-gnutls.c tls-sspi.c

=== doc/Makefile ===
#
# IPP documentation makefile.
#
# Copyright 2014-2017 by the IEEE-ISTO Printer Working Group.
# Copyright 2015-2017 by Apple Inc.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS		=	\
			mantohtml.o
TARGETS		=	\
			mantohtml
MAN1		=	\
			$(IPPFIND_MAN) \
			ipptool.man \
			$(IPPTRANSFORM_MAN) \
			$(IPPTRANSFORM3D_MAN)
MAN5		=	\
			ipptoolfile.man

MAN8		=	\
			ippproxy.man \
			ippserver.man
HTML		=	\
			$(IPPFIND_HTML) \
			ippproxy.html \
			ippserver.html \
			ipptool.html \
			ipptoolfile.html \
			$(IPPTRANSFORM_HTML) \
			$(IPPTRANSFORM3D_HTML)


#
# Rules for converting man pages to HTML...
#

.SUFFIXES:	.html .man
.man.html:	mantohtml
	echo Generating $@...
	./mantohtml $< >$@


#
# Make all targets...
#

all:		$(TARGETS) $(HTML)


#
# Clean all object files...
#

clean:
	$(RM) $(TARGETS) $(OBJS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install man pages...
#

install:
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man1
	for file in $(MAN1); do \
		man="`basename $$file .man | sed -e '1,$$s/^ipp/$(IPP)/'`.1"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man1/$$man; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man5
	for file in $(MAN5); do \
		man="`basename $$file .man | sed -e '1,$$s/^ipp/$(IPP)/'`.5"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man5/$$man; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man8
	for file in $(MAN8); do \
		man="`basename $$file .man | sed -e '1,$$s/^ipp/$(IPP)/'`.8"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man8/$$man; \
	done


#
# mantohtml
#

mantohtml:	mantohtml.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ mantohtml.o $(LIBS)


#
# Dependencies...
#

include Dependencies

=== server/Makefile ===
#
# Makefile for sample IPP server implementation.
#
# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
# Copyright © 2015-2018 by Apple Inc.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


#
# Object files...
#

OBJS =	\
		client.o \
		conf.o \
		device.o \
		ipp.o \
		job.o \
		log.o \
		main.o \
		printer.o \
		subscription.o \
		transform.o


#
# Targets in this directory...
#

TARGETS =	ippserver


#
# Make all targets...
#

all:		$(TARGETS)


#
# Remove object and target files...
#

clean:
	$(RM) $(OBJS) $(TARGETS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install the server.
#

install:	all
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(sbindir)
	$(INSTALL_BIN) ippserver $(BUILDROOT)$(sbindir)/$(IPP)server


#
# Test the server.
#

test:


#
# ippserver
#

ippserver:	$(OBJS) ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)


#
# printer-png.h
#

printer-png.h:	printer.png
	echo "Generating printer-png.h from printer.png..."
	echo "static const unsigned char printer_png[] =" >printer-png.h
	echo "{" >>printer-png.h
	od -t x1 printer.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer-png.h
	echo "};" >>printer-png.h


#
# printer3d-png.h
#

printer3d-png.h:	printer3d.png
	echo "Generating printer3d-png.h from printer3d.png..."
	echo "static const unsigned char printer3d_png[] =" >printer3d-png.h
	echo "{" >>printer3d-png.h
	od -t x1 printer3d.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer3d-png.h
	echo "};" >>printer3d-png.h


#
# Dependencies...
#

include Dependencies

=== tools/Makefile ===
#
# IPP tools makefile.
#
# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
# Copyright © 2007-2018 by Apple Inc.
# Copyright © 1997-2006 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS		=	\
			ippfind.o \
			ippproxy.o \
			ipptool.o \
			ipptransform.o \
			ipptransform3d.o
TARGETS         =       \
                        $(BIN_TARGETS) \
                        $(SBIN_TARGETS)
BIN_TARGETS	=	\
			$(IPPFIND_BIN) \
			ipptool \
			$(IPPTRANSFORM_BIN) \
			$(IPPTRANSFORM3D_BIN)
SBIN_TARGETS	=	\
			ippproxy


#
# Make all targets...
#

all:		$(TARGETS)


#
# Clean all object files...
#

clean:
	$(RM) $(TARGETS) $(OBJS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install all tools.
#

install:	all
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(bindir)
	for file in $(BIN_TARGETS); do \
		destfile=`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`; \
		$(INSTALL_BIN) $$file $(BUILDROOT)$(bindir)/$$destfile; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(sbindir)
	for file in $(SBIN_TARGETS); do \
		destfile=`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`; \
		$(INSTALL_BIN) $$file $(BUILDROOT)$(sbindir)/$$destfile; \
	done


#
# Test all tools.
#

test:


#
# ippfind
#

ippfind:	ippfind.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ ippfind.o $(LIBS)


#
# ippproxy
#

ippproxy:	ippproxy.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ ippproxy.o $(LIBS)


#
# ipptool
#

ipptool:	ipptool.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ ipptool.o $(LIBS)


#
# ipptransform
#

ipptransform:	ipptransform.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ ipptransform.o $(LIBS)


#
# ipptransform3d
#

ipptransform3d:	ipptransform3d.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ ipptransform3d.o $(LIBS)


#
# Dependencies...
#

include Dependencies

=== vcnet/regex/Makefile ===
# You probably want to take -DREDEBUG out of CFLAGS, and put something like
# -O in, *after* testing (-DREDEBUG strengthens testing by enabling a lot of
# internal assertion checking and some debugging facilities).
# Put -Dconst= in for a pre-ANSI compiler.
# Do not take -DPOSIX_MISTAKE out.
# REGCFLAGS isn't important to you (it's for my use in some special contexts).
CFLAGS=-I. -DPOSIX_MISTAKE -DREDEBUG $(REGCFLAGS)

# If you have a pre-ANSI compiler, put -o into MKHFLAGS.  If you want
# the Berkeley __P macro, put -b in.
MKHFLAGS=

# Flags for linking but not compiling, if any.
LDFLAGS=

# Extra libraries for linking, if any.
LIBS=

# Internal stuff, should not need changing.
OBJPRODN=regcomp.o regexec.o regerror.o regfree.o
OBJS=$(OBJPRODN) split.o debug.o main.o
H=cclass.h cname.h regex2.h utils.h
REGSRC=regcomp.c regerror.c regexec.c regfree.c
ALLSRC=$(REGSRC) engine.c debug.c main.c split.c

# Stuff that matters only if you're trying to lint the package.
LINTFLAGS=-I. -Dstatic= -Dconst= -DREDEBUG
LINTC=regcomp.c regexec.c regerror.c regfree.c debug.c main.c
JUNKLINT=possible pointer alignment|null effect

# arrangements to build forward-reference header files
.SUFFIXES:	.ih .h
.c.ih:
	sh ./mkh $(MKHFLAGS) -p $< >$@

default:	r

lib:	purge $(OBJPRODN)
	rm -f libregex.a
	ar crv libregex.a $(OBJPRODN)

purge:
	rm -f *.o

# stuff to build regex.h
REGEXH=regex.h
REGEXHSRC=regex2.h $(REGSRC)
$(REGEXH):	$(REGEXHSRC) mkh
	sh ./mkh $(MKHFLAGS) -i _REGEX_H_ $(REGEXHSRC) >regex.tmp
	cmp -s regex.tmp regex.h 2>/dev/null || cp regex.tmp regex.h
	rm -f regex.tmp

# dependencies
$(OBJPRODN) debug.o:	utils.h regex.h regex2.h
regcomp.o:	cclass.h cname.h regcomp.ih
regexec.o:	engine.c engine.ih
regerror.o:	regerror.ih
debug.o:	debug.ih
main.o:	main.ih

# tester
re:	$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(OBJS) $(LIBS) -o $@

# regression test
r:	re tests
	./re <tests
	./re -el <tests
	./re -er <tests

# 57 variants, and other stuff, for development use -- not useful to you
ra:	./re tests
	-./re <tests
	-./re -el <tests
	-./re -er <tests

rx:	./re tests
	./re -x <tests
	./re -x -el <tests
	./re -x -er <tests

t:	./re tests
	-time ./re <tests
	-time ./re -cs <tests
	-time ./re -el <tests
	-time ./re -cs -el <tests

l:	$(LINTC)
	lint $(LINTFLAGS) -h $(LINTC) 2>&1 | egrep -v '$(JUNKLINT)' | tee lint

fullprint:
	ti README WHATSNEW notes todo | list
	ti *.h | list
	list *.c
	list regex.3 regex.7

print:
	ti README WHATSNEW notes todo | list
	ti *.h | list
	list reg*.c engine.c


mf.tmp:	Makefile
	sed '/^REGEXH=/s/=.*/=regex.h/' Makefile | sed '/#DEL$$/d' >$@

DTRH=cclass.h cname.h regex2.h utils.h
PRE=COPYRIGHT README WHATSNEW
POST=mkh regex.3 regex.7 tests $(DTRH) $(ALLSRC) fake/*.[ch]
FILES=$(PRE) Makefile $(POST)
DTR=$(PRE) Makefile=mf.tmp $(POST)
dtr:	$(FILES) mf.tmp
	makedtr $(DTR) >$@
	rm mf.tmp

cio:	$(FILES)
	cio $(FILES)

rdf:	$(FILES)
	rcsdiff -c $(FILES) 2>&1 | p

# various forms of cleanup
tidy:
	rm -f junk* core core.* *.core dtr *.tmp lint

clean:	tidy
	rm -f *.o *.s *.ih re libregex.a

# don't do this one unless you know what you're doing
spotless:	clean
	rm -f mkh regex.h

=== debian/changelog ===
ippsample (0.0+20180213-0ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:59:54 +1100

ippsample (0.0+20180213-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:06:32 +0000

ippsample (0.0+20180213-0ubuntu1) bionic; urgency=low

  * Initial Release.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Tue, 13 Feb 2018 18:42:01 +0100

=== debian/control ===
Source: ippsample
Standards-Version: 4.1.3
Priority: optional
Section: net
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders:
 Didier Raboud <odyx@debian.org>,
 Till Kamppeter <till.kamppeter@gmail.com>,
Build-Depends:
 debhelper (>= 10.2.5~),
 dh-exec,
 dpkg-dev (>= 1.16.1~),
 patch,
 autoconf,
 avahi-daemon,
 avahi-utils,
 libavahi-client-dev,
 libgnutls28-dev,
 libjpeg-dev,
 libnss-mdns,
 libpng-dev,
 zlib1g-dev
Homepage: http://istopwg.github.io/ippsample/

Package: ippsample
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: cups-ipp-utils
Replaces: cups-ipp-utils
Provides: cups-ipp-utils
Multi-Arch: foreign
Description: ippsample - Samples/development tools for the IPP
 The ippsample project provides sample implementations of an IPP
 Client, Proxy, Server, and other tools. It is based on the CUPS
 source code and is maintained by the PWG IPP workgroup.

=== debian/rules ===
#!/usr/bin/make -f

derives_from_ubuntu := $(shell (dpkg-vendor --derives-from Ubuntu && echo "yes") || echo "no")

# Enabling PIE globally doesn't work, but ./configure already enables PIE
# where necessary.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The build system uses only DSOFLAGS but not LDFLAGS to build some libraries.
# Add LDFLAGS to enable (hardening) build flags.
export DSOFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

%:
	dh $@ --without autoreconf

override_dh_auto_install:
	dh_auto_install -- install BUILDROOT=$(shell pwd)/debian/tmp

override_dh_install:
	dh_install

	# Ensure that we don't ship anything in /var/run or /run
	rm -rf debian/cups*/var/run
	rm -rf debian/cups*/run

override_dh_auto_clean:
	[ ! -f Makedefs ] || dh_auto_clean
	[ ! -f Makedefs ] || make distclean

## ippsample 0.0.0~git20220215.f365352

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #
 # Top-level Makefile for IPP sample implementations.
 #
-# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
-# Copyright © 2007-2018 by Apple Inc.
+# Copyright © 2014-2019 by the IEEE-ISTO Printer Working Group.
+# Copyright © 2007-2019 by Apple Inc.
 # Copyright © 1997-2007 by Easy Software Products, all rights reserved.
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
@@ -66,7 +66,7 @@
 #
 
 install:
-	for dir in $(DIRS) doc; do \
+	for dir in $(DIRS) examples man; do \
 		echo Installing in $$dir...; \
 		(cd $$dir; $(MAKE) $(MFLAGS) install) || exit 1; \
 	done

=== cups/Makefile ===
--- 
+++ 
@@ -33,7 +33,6 @@
 		dest-options.o \
 		dir.o \
 		encode.o \
-		error.o \
 		file.o \
 		getputfile.o \
 		globals.o \
@@ -53,7 +52,9 @@
 		notify.o \
 		options.o \
 		pwg-media.o \
-		raster.o \
+		raster-error.o \
+		raster-stream.o \
+		raster-stubs.o \
 		request.o \
 		snprintf.o \
 		string.o \
@@ -133,6 +134,10 @@
 	for file in $(HEADERS); do \
 		$(INSTALL_DATA) $$file $(BUILDROOT)$(includedir)/cups; \
 	done
+	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(datadir)/cups
+	for file in cupspm.epub cupspm.html cupspm.png; do \
+		$(INSTALL_DATA) $$file $(BUILDROOT)$(datadir)/cups; \
+	done
 
 
 #
@@ -166,12 +171,13 @@
 libcups2.def: $(OBJS) Makefile
 	echo Generating $@...
 	echo "LIBRARY libcups2" >libcups2.def
-	echo "VERSION 2.12" >>libcups2.def
+	echo "VERSION 2.14" >>libcups2.def
 	echo "EXPORTS" >>libcups2.def
-	(nm $(OBJS) 2>/dev/null | grep "T _" | awk '{print $$3}'; \
-	 echo __cups_strcpy; echo __cups_strlcat; echo __cups_strlcpy) | \
+	(nm $(LIBOBJS) 2>/dev/null | grep "T _" | awk '{print $$3}'; \
+	 echo __cups_strcpy; echo __cups_strlcat; echo __cups_strlcpy; \
+	 echo __cups_snprintf; echo __cups_vsnprintf; echo __cups_gettimeofday) | \
 		grep -v -E \
-		    -e 'cups_debug|Apple|GSSService|SetNegotiate' \
+		    -e 'cups_debug|Apple|FileCheck|GSSService|SetNegotiate' \
 		    -e 'Block$$' | \
 		sed -e '1,$$s/^_//' | sort >>libcups2.def
 
@@ -213,69 +219,20 @@
 # Automatic API help files...
 #
 
-APISOURCES =	\
-		auth.c \
-		cups.h \
-		dest.c \
-		dest-job.c \
-		dest-localization.c \
-		dest-options.c \
-		encode.c \
-		error.c \
-		getputfile.c \
-		hash.c \
-		http.c \
-		http.h \
-		http-addr.c \
-		http-addrlist.c \
-		http-support.c \
-		ipp.c \
-		ipp.h \
-		ipp-support.c \
-		md5passwd.c \
-		notify.c \
-		options.c \
-		pwg.h \
-		pwg-media.c \
-		raster.c \
-		raster.h \
-		request.c \
-		tls.c \
-		usersys.c \
-		util.c
+APISOURCES =	$(LIBOBJS:.o=.c) $(HEADERS)
 
 apihelp:
 	echo Generating CUPS API help files...
-	mxmldoc --title "CUPS API Programming Guide" \
-		--author "Michael R Sweet" \
-		--copyright "Copyright 2007-2017 by Apple Inc." \
-		--docversion $(IPPSAMPLE_VERSION) \
-		--intro api.intro \
-		api.xml $(APISOURCES) >../doc/api.html
-	mxmldoc --title "CUPS API Programming Guide" \
-		--author "Michael R Sweet" \
-		--copyright "Copyright 2007-2017 by Apple Inc." \
-		--docversion $(IPPSAMPLE_VERSION) \
-		--intro api.intro \
-		--epub ../doc/api.epub \
-		api.xml
-	if test `uname` = Darwin; then \
-		mxmldoc --title "CUPS API Programming Guide" \
-			--author "Michael R Sweet" \
-			--copyright "Copyright 2007-2017 by Apple Inc." \
-			--docversion $(IPPSAMPLE_VERSION) \
-			--intro api.intro \
-			--docset org.pwg.ippsample.docset \
-			--feedname org.pwg.ippsample \
-			--feedurl https://istopwg.github.io/ippsample/org.pwg.ippsample.atom \
-			api.xml; \
-		$(RM) org.pwg.ippsample.atom; \
-		xcrun docsetutil package --output org.pwg.ippsample.xar \
-			--atom org.pwg.ippsample.atom \
-			--download-url https://istopwg.github.io/ippsample/org.pwg.ippsample.xar \
-			org.pwg.ippsample.docset || exit 1; \
-	fi
-	$(RM) api.xml
+	$(RM) cupspm.xml
+	codedoc --section "Programming" --body cupspm.md \
+		cupspm.xml \
+		auth.c cups.h dest*.c encode.c http.h http*.c ipp.h ipp*.c \
+		options.c tls-darwin.c usersys.c util.c \
+		--coverimage cupspm.png \
+		--epub cupspm.epub
+	codedoc --section "Programming" --body cupspm.md \
+		cupspm.xml > cupspm.html
+	$(RM) cupspm.xml
 
 
 #

=== examples/Makefile ===
#
# IPP examples makefile.
#
# Copyright © 2021 by the IEEE-ISTO Printer Working Group.
# Copyright © 2019 by Apple Inc.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


DOCFILES	=	\
			box.3mf \
			color.jpg \
			cube_gears.3mf \
			cylinder.3mf \
			document-a4.pdf \
			document-a4.ps \
			document-letter.pdf \
			document-letter.ps \
			dodeca_chain_loop.3mf \
			gray.jpg \
			heartgears.3mf \
			ipp-3d-with-grommet.stl \
			ipp-3d.3mf \
			ipp-3d.stl \
			onepage-a4-300-black-1.pwg \
			onepage-a4.pdf \
			onepage-a4.ps \
			onepage-a4.sla \
			onepage-letter-300-black-1.pwg \
			onepage-letter.pdf \
			onepage-letter.ps \
			onepage-letter.sla \
			sphere.3mf \
			testfile.jpg \
			testfile.pcl \
			testfile.pdf \
			testfile.ps \
			testfile.txt \
			torus.3mf \
			vector.pdf

TESTFILES	=	\
			cancel-current-job.test \
			cancel-job.test \
			create-job-3d.test \
			create-job-format.test \
			create-job-sheets.test \
			create-job-timeout.test \
			create-job.test \
			create-printer-pcl.test \
			create-printer-pwg.test \
			create-printer-subscription.test \
			create-resource-strings.test \
			delete-printer.test \
			disable-printer.test \
			enable-printer.test \
			get-completed-jobs.test \
			get-job-attributes.test \
			get-job-template-attributes.test \
			get-jobs.test \
			get-notifications.test \
			get-printer-attributes-2.0.test \
			get-printer-attributes.test \
			get-printer-description-attributes.test \
			get-printers.test \
			get-subscriptions.test \
			get-system-attributes.test \
			identify-printer-display.test \
			identify-printer-multiple.test \
			identify-printer.test \
			ipp-1.1.test \
			ipp-2.0.test \
			ipp-2.1.test \
			ipp-2.2.test \
			ipp-3d.test \
			ipp-everywhere.test \
			pause-printer.test \
			print-job.test \
			print-job-and-wait.test \
			print-job-deflate.test \
			print-job-draft.test \
			print-job-gzip.test \
			print-job-hold.test \
			print-job-media-col.test \
			print-job-media-needed.test \
			print-job-password.test \
			print-uri.test \
			pwg5100.1.test \
			pwg5100.2.test \
			pwg5100.3.test \
			pwg5100.5.test \
			pwg5100.6.test \
			pwg5100.7.test \
			pwg5100.8.test \
			pwg5100.9.test \
			pwg5100.11.test \
			pwg5100.15.test \
			pwg5100.16.test \
			pwg5100.17.test \
			resume-printer.test \
			rfc3380.test \
			rfc3995-3996.test \
			rfc3998.test \
			set-attrs-hold.test \
			set-system-attributes.test \
			validate-job.test


#
# Make all targets...
#

all:


#
# Clean all object files...
#

clean:


#
# Update dependencies (without system header dependencies...)
#

depend:


#
# Install...
#

install:
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(datadir)/ipptool
	for file in $(TESTFILES) $(DOCFILES); do \
		$(INSTALL_DATA) $$file $(BUILDROOT)$(datadir)/ipptool; \
	done

=== man/Makefile ===
#
# IPP documentation makefile.
#
# Copyright © 2014-2019 by the IEEE-ISTO Printer Working Group.
# Copyright © 2015-2019 by Apple Inc.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS		=	\
			mantohtml.o
TARGETS		=	\
			mantohtml
MAN1		=	\
			ipp3dprinter.1 \
			ippeveprinter.1 \
			$(IPPFIND_MAN) \
			ipptool.1
MAN5		=	\
			ipptoolfile.5

MAN7		=	\
			ippdoclint.7 \
			$(IPPTRANSFORM_MAN) \
			$(IPPTRANSFORM3D_MAN)
MAN8		=	\
			ippproxy.8 \
			ippserver.8
HTML		=	\
			ipp3dprinter.html \
			ippdoclint.html \
			ippeveprinter.html \
			$(IPPFIND_HTML) \
			ippproxy.html \
			ippserver.html \
			ipptool.html \
			ipptoolfile.html \
			$(IPPTRANSFORM_HTML) \
			$(IPPTRANSFORM3D_HTML)


#
# Rules for converting man pages to HTML...
#

.SUFFIXES:	.1 .5 .7 .8 .html
.1.html .5.html .7.html .8.html:	mantohtml
	echo Generating $@...
	./mantohtml $< >$@


#
# Make all targets...
#

all:		$(TARGETS) $(HTML)


#
# Clean all object files...
#

clean:
	$(RM) $(TARGETS) $(OBJS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install man pages...
#

install:
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man1
	for file in $(MAN1); do \
		man="`echo $$file .| sed -e '1,$$s/^ipp/$(IPP)/'`"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man1/$$man; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man5
	for file in $(MAN5); do \
		man="`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man5/$$man; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man7
	for file in $(MAN7); do \
		man="`echo $$file .| sed -e '1,$$s/^ipp/$(IPP)/'`"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man7/$$man; \
	done
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man8
	for file in $(MAN8); do \
		man="`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`"; \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man8/$$man; \
	done


#
# mantohtml
#

mantohtml:	mantohtml.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ mantohtml.o $(LIBS)


#
# Dependencies...
#

include Dependencies

=== server/Makefile ===
--- 
+++ 
@@ -15,7 +15,8 @@
 # Object files...
 #
 
-OBJS =	\
+OBJS 	=	\
+		auth.o \
 		client.o \
 		conf.o \
 		device.o \
@@ -24,6 +25,7 @@
 		log.o \
 		main.o \
 		printer.o \
+		resource.o \
 		subscription.o \
 		transform.o
 
@@ -80,26 +82,19 @@
 
 ippserver:	$(OBJS) ../cups/libcups.a
 	echo Linking $@...
-	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(PAMLIBS) $(LIBS)
 
 
 #
-# printer-png.h
+# Embedded PNG headers...
 #
 
-printer-png.h:	printer.png
+pngheaders:
 	echo "Generating printer-png.h from printer.png..."
 	echo "static const unsigned char printer_png[] =" >printer-png.h
 	echo "{" >>printer-png.h
 	od -t x1 printer.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer-png.h
 	echo "};" >>printer-png.h
-
-
-#
-# printer3d-png.h
-#
-
-printer3d-png.h:	printer3d.png
 	echo "Generating printer3d-png.h from printer3d.png..."
 	echo "static const unsigned char printer3d_png[] =" >printer3d-png.h
 	echo "{" >>printer3d-png.h

=== tools/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #
 # IPP tools makefile.
 #
-# Copyright © 2014-2018 by the IEEE-ISTO Printer Working Group.
-# Copyright © 2007-2018 by Apple Inc.
+# Copyright © 2014-2021 by the IEEE-ISTO Printer Working Group.
+# Copyright © 2007-2019 by Apple Inc.
 # Copyright © 1997-2006 by Easy Software Products, all rights reserved.
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
@@ -13,6 +13,9 @@
 
 
 OBJS		=	\
+			ipp3dprinter.o \
+			ippdoclint.o \
+			ippeveprinter.o \
 			ippfind.o \
 			ippproxy.o \
 			ipptool.o \
@@ -20,12 +23,17 @@
 			ipptransform3d.o
 TARGETS         =       \
                         $(BIN_TARGETS) \
+                        $(COMMAND_TARGETS) \
                         $(SBIN_TARGETS)
-BIN_TARGETS	=	\
-			$(IPPFIND_BIN) \
-			ipptool \
+COMMAND_TARGETS	=	\
+			ippdoclint \
 			$(IPPTRANSFORM_BIN) \
 			$(IPPTRANSFORM3D_BIN)
+BIN_TARGETS	=	\
+			ipp3dprinter \
+			ippeveprinter \
+			$(IPPFIND_BIN) \
+			ipptool
 SBIN_TARGETS	=	\
 			ippproxy
 
@@ -63,6 +71,12 @@
 		destfile=`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`; \
 		$(INSTALL_BIN) $$file $(BUILDROOT)$(bindir)/$$destfile; \
 	done
+	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(libexecdir)/cups/command
+	for file in $(COMMAND_TARGETS); do \
+		destfile=`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`; \
+		$(INSTALL_BIN) $$file $(BUILDROOT)$(bindir)/$$destfile; \
+		ln -sf ../../../bin/$$destfile $(BUILDROOT)$(libexecdir)/cups/command/$$file; \
+	done
 	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(sbindir)
 	for file in $(SBIN_TARGETS); do \
 		destfile=`echo $$file | sed -e '1,$$s/^ipp/$(IPP)/'`; \
@@ -75,6 +89,48 @@
 #
 
 test:
+
+
+#
+# Make icon resource headers...
+#
+
+resheaders:
+	for file in printer printer-sm printer-lg; do \
+		var="`echo $$file | sed -e '1,$$s/-/_/g'`"; \
+		echo "Generating $$file-png.h from $$file.png..."; \
+		echo "static const unsigned char $${var}_png[] =" >$${file}-png.h; \
+		echo "{" >>$${file}-png.h; \
+		od -t x1 -A n -v $$file.png | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>$${file}-png.h; \
+		echo "};" >>$${file}-png.h; \
+	done
+
+
+#
+# ipp3dprinter
+#
+
+ipp3dprinter:	ipp3dprinter.o ../cups/libcups.a
+	echo Linking $@...
+	$(CC) $(LDFLAGS) -o $@ ipp3dprinter.o $(LIBS)
+
+
+#
+# ippdoclint
+#
+
+ippdoclint:	ippdoclint.o ../cups/libcups.a
+	echo Linking $@...
+	$(CC) $(LDFLAGS) -o $@ ippdoclint.o $(LIBS)
+
+
+#
+# ippeveprinter
+#
+
+ippeveprinter:	ippeveprinter.o ../cups/libcups.a
+	echo Linking $@...
+	$(CC) $(LDFLAGS) -o $@ ippeveprinter.o $(PAMLIBS) $(LIBS)
 
 
 #

=== debian/changelog ===
ippsample (0.0.0~git20220215.f365352-1) unstable; urgency=medium

  [ Thorsten Alteholz ]
  * revert to 0.0~git20220215.f365352-1, the new upstream version
    needs cups3
    (Thanks to Bastian Germann for the suggestion)
    (Closes: #1042570)
  * debian/control: remove explicitly dependency to libcups2
    (Closes: #1069333)
  * debian/control: bump standard to 4.7.2 (no changes)

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.1, no changes needed.

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 25 Nov 2025 22:50:59 +0100

=== debian/control ===
Source: ippsample
Priority: optional
Section: net
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>,
		Till Kamppeter <till.kamppeter@gmail.com>
Build-Depends: debhelper-compat (= 13),
		avahi-daemon,
		avahi-utils,
		libavahi-client-dev,
		libgnutls28-dev,
		libjpeg-dev,
		libnss-mdns,
		libpng-dev,
		zlib1g-dev,
		libmupdf-dev,
		libcups2-dev
Homepage: https://istopwg.github.io/ippsample/
Standards-Version: 4.7.2
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/printing-team/ippsample
Vcs-Git: https://salsa.debian.org/printing-team/ippsample.git

Package: ippsample
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, ippsample-data
Conflicts: cups-ipp-utils
Multi-Arch: foreign
Description: samples/development tools for the IPP
 The ippsample project provides sample implementations of an IPP
 Client, Proxy, Server, and other tools. It is based on the CUPS
 source code and is maintained by the PWG IPP workgroup.

Package: ippsample-data
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: ippsample (>= ${source:Version})
Conflicts: cups-ipp-utils
Description: samples/development tools for the IPP (data)
 The ippsample project provides sample implementations of an IPP
 Client, Proxy, Server, and other tools. It is based on the CUPS
 source code and is maintained by the PWG IPP workgroup.
 .
 This package contains files for /usr/share

=== debian/rules ===
#!/usr/bin/make -f

# Enabling PIE globally doesn't work, but ./configure already enables PIE
# where necessary.
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# as needed is the default now and is just needed for backports
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The build system uses only DSOFLAGS but not LDFLAGS to build some libraries.
# Add LDFLAGS to enable (hardening) build flags.
export DSOFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# autoreconf intentionally deactivated, upstream knows more about the real reason
%:
	dh $@ --without autoreconf

override_dh_auto_clean:
	[ ! -f Makedefs ] || dh_auto_clean
	[ ! -f Makedefs ] || make distclean

# for whatever reason mupdf is not really detected here
override_dh_auto_configure:
	dh_auto_configure -- --with-pdfrip=auto

override_dh_auto_test:
	echo "libcups tests do not really work here, so deactivating them for now"

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l$(shell pwd)/debian/tmp/usr/lib/$(DEB_BUILD_GNU_TYPE)/
